// page 2 - Radio Data

void show_2() {
  if (page != pageTmp) {
    show_2_init();
  }

  send_msp(MSP_RC, 0, 0);
  readData();
  
  for (int j = 0; j <= 7; j++) {
    uint16_t radio = readUInt16(inBuf, j * 2); // get data from receive buffer
    if (radio != varTmp[j]) { // if data was changed we need change the related bar
      tft.fillRect(RADIO_X, RADIO_Y + (10 * j), 24, 7, ST7735_BLACK); // clear old digital data
      tft.setCursor(RADIO_X, RADIO_Y + (10 * j));
      tft.print(radio); // print new digital data
      if (radio < varTmp[j]) {
        if ((radio < 1000) && (radio > 0)) {
          radio = 1000;
        }
        for (int i = norm(radio); i <= norm(varTmp[j]); i++) {
          tft.drawFastVLine(i, RADIO_Y + (10 * j), 7, ST7735_BLACK);  // clear to black the overage of bar
        }
      }
      else {
        for (int i = norm(varTmp[j]); i <= norm(radio); i++) {
          tft.drawFastVLine(i, RADIO_Y + (10 * j), 7, ST7735_GREEN); // increase length of bar
        }
      }
    }
    varTmp[j] = radio; // store new data to temp storage
  }  
  checkArm(); // show the red bar if armed
}

void show_2_init() {
  pageTmp = page;
  tft.fillScreen(ST7735_BLACK);  // clear display to black
  tft.setTextColor(ST7735_WHITE);

  tft.setCursor(PAGE_NAME_X, PAGE_NAME_Y);
  tft.print("RADIO");

  tft.setCursor(PAGE_NUM_X, PAGE_NUM_Y);
  tft.print(page, DEC);
  tft.print("/");
  tft.print(TOTAL_PAGE, DEC);

  tft.setCursor(RADIO_X - 30, RADIO_Y);
  tft.print("ROL");

  tft.setCursor(RADIO_X - 30, RADIO_Y + 10);
  tft.print("PIT");

  tft.setCursor(RADIO_X - 30, RADIO_Y + 20);
  tft.print("YAW");

  tft.setCursor(RADIO_X - 30, RADIO_Y + 30);
  tft.print("THR");

  tft.setCursor(RADIO_X - 30, RADIO_Y + 40);
  tft.print("AUX1");

  tft.setCursor(RADIO_X - 30, RADIO_Y + 50);
  tft.print("AUX2");

  tft.setCursor(RADIO_X - 30, RADIO_Y + 60);
  tft.print("AUX3");

  tft.setCursor(RADIO_X - 30, RADIO_Y + 70);
  tft.print("AUX4");

  varTmp[0] = 1000;
  varTmp[1] = 1000;
  varTmp[2] = 1000;
  varTmp[3] = 1000;
  varTmp[4] = 1000;
  varTmp[5] = 1000;
  varTmp[6] = 1000;
  varTmp[7] = 1000;
}







