// page 3 -  Active Mode

/************************************************************************************
* here we use a bit of magic to store the string constants into program space       *
* and read strings back. MAY NOT be compiled if use Arduino IDE earleier than 1.0.6 *
* refer to http://arduino.cc/en/Reference/PROGMEM for more information              *
*************************************************************************************/

const char string_0[] PROGMEM = "ARM";
const char string_1[] PROGMEM = "ANGLE";
const char string_2[] PROGMEM = "HORIZON";
const char string_3[] PROGMEM = "BARO";
const char string_4[] PROGMEM = "VARIO";
const char string_5[] PROGMEM = "MAG";
const char string_6[] PROGMEM = "HEADFREE";
const char string_7[] PROGMEM = "HEADADJ";
const char string_8[] PROGMEM = "CAMSTAB";
const char string_9[] PROGMEM = "CAMTRIG";
const char string_10[] PROGMEM = "GPS HOME";
const char string_11[] PROGMEM = "GPS HOLD";
const char string_12[] PROGMEM = "PASSTHRU";
const char string_13[] PROGMEM = "BEEPER";
const char string_14[] PROGMEM = "LEDMAX";
const char string_15[] PROGMEM = "LEDLOW";
const char string_16[] PROGMEM = "LLIGHTS";
const char string_17[] PROGMEM = "CALIB";
const char string_18[] PROGMEM = "GOVERNOR";
const char string_19[] PROGMEM = "OSD SW";

const char* const boxnames[] PROGMEM = {
  string_0,
  string_1,
  string_2,
  string_3,
  string_4,
  string_5,
  string_6,
  string_7,
  string_8,
  string_9,
  string_10,
  string_11,
  string_12,
  string_13,
  string_14,
  string_15,
  string_16,
  string_17,
  string_18,
  string_19
};

char strBuffer[8];

void show_3() {
  if (page != pageTmp) {
    show_3_init();
  }

  send_msp(MSP_STATUS, 0, 0);
  readData();
  uint32_t boxflags = readUInt32(inBuf, 6); // list of flags

  if (boxflags != varTmpA) { // if boxflags was changed
    send_msp(MSP_BOXIDS, 0, 0);
    readData();
    int boxX = BOXNAMES_X;
    int boxY = BOXNAMES_Y;

    for (int i = 0; i < dataSize; i = i + 2) {
      int j = inBuf[i];
      tft.setCursor(boxX, boxY + 10 * i / 2);
      if (bitRead(boxflags, i)) {
        tft.setTextColor(ST7735_YELLOW);
        strcpy_P(strBuffer, (char*)pgm_read_word(&(boxnames[j])));
        tft.print(strBuffer);
        tft.setTextColor(ST7735_WHITE);
      }
      else {
        strcpy_P(strBuffer, (char*)pgm_read_word(&(boxnames[j])));
        tft.print(strBuffer);
      }
      tft.setCursor(boxX + 80, boxY + 10 * i / 2);
      if ((i + 1) < dataSize) {
        j = inBuf[i + 1];
        if (bitRead(boxflags, i + 1)) {
          tft.setTextColor(ST7735_YELLOW);
          strcpy_P(strBuffer, (char*)pgm_read_word(&(boxnames[j])));
          tft.print(strBuffer);
          tft.setTextColor(ST7735_WHITE);
        }
        else {
          strcpy_P(strBuffer, (char*)pgm_read_word(&(boxnames[j])));
          tft.print(strBuffer);
        }
      }
    }
    varTmpA = boxflags;
  }

  checkArm(); // show the red bar if armed
}

void show_3_init() {
  varTmpA = 1000;
  pageTmp = page;
  tft.fillScreen(ST7735_BLACK);  // clear display to black
  tft.setTextColor(ST7735_WHITE);

  tft.setCursor(PAGE_NAME_X - 15, PAGE_NAME_Y);
  tft.print("ACTIVE MODE");

  tft.setCursor(PAGE_NUM_X, PAGE_NUM_Y);
  tft.print(page, DEC);
  tft.print("/");
  tft.print(TOTAL_PAGE, DEC);
}
