// page 4 - GPS data

void show_4() {
  if (page != pageTmp) {
    show_4_init();
  }

  send_msp(MSP_STATUS, 0, 0);
  readData();
  uint16_t sensors = readUInt16(inBuf, 4); // get list of available sensors

  if (bitRead(sensors, 3)) {  // if GPS available

    send_msp(MSP_RAW_GPS, 0, 0);
    readData();

    int8_t GPSfix = inBuf[0];
    if (GPSfix != GPSfixTmp) {
      if (GPSfix == 0) {
        tft.fillCircle(GPS_FIX_X + 54, GPS_FIX_Y + 3, 3, ST7735_RED); // draw red dot if no fix
      }
      else {
        tft.fillCircle(GPS_FIX_X + 54, GPS_FIX_Y + 3, 3, ST7735_GREEN); // draw green dot
      }
      GPSfixTmp = GPSfix;
    }

    int8_t GPSsat = inBuf[1];
    if (GPSsat != GPSsatTmp) {
      tft.fillRect(GPS_NUMSAT_X + 52, GPS_NUMSAT_Y, 12, 7, ST7735_BLACK);
      tft.setCursor(GPS_NUMSAT_X + 52, GPS_NUMSAT_Y);
      tft.print(GPSsat, DEC);
      GPSsatTmp = GPSsat;
    }

    uint32_t GPSlat = readUInt32(inBuf, 2);
    if (GPSlat != varTmpA) {
      tft.fillRect(GPS_LAT_X + 26, GPS_LAT_Y, 60, 7, ST7735_BLACK);
      tft.setCursor(GPS_LAT_X + 26, GPS_LAT_Y);
      tft.print(GPSlat, DEC);
      varTmpA = GPSlat;
    }

    uint32_t GPSlon = readUInt32(inBuf, 6);
    if (GPSlon != varTmpB) {
      tft.fillRect(GPS_LON_X + 26, GPS_LON_Y, 60, 7, ST7735_BLACK);
      tft.setCursor(GPS_LON_X + 26, GPS_LON_Y);
      tft.print(GPSlon, DEC);
      varTmpB = GPSlon;
    }

    uint16_t GPSalt = readUInt16(inBuf, 10);
    if (GPSalt != varTmp[2]) {
      tft.fillRect(GPS_ALT_X + 56, GPS_ALT_Y, 24, 7, ST7735_BLACK);
      tft.setCursor(GPS_ALT_X + 56, GPS_ALT_Y);
      tft.print(GPSalt, DEC);
      varTmp[2]  = GPSalt;
    }

    /*
    uint16_t GPSspeed = readUInt16(inBuf, 12);
    if (GPSspeed != varTmp[3]) {
      tft.fillRect(GPS_SPEED_X + 38, GPS_SPEED_Y, 24, 7, ST7735_BLACK);
      tft.setCursor(GPS_SPEED_X + 38, GPS_SPEED_Y);
      tft.print(GPSspeed, DEC);
      varTmp[3] = GPSspeed;
    }
    */

    /*
    uint16_t GPScourse = readUInt16(inBuf, 14);
    if (GPScourse != varTmp[4]) {
      tft.fillRect(GPS_COURSE_X + 46, GPS_COURSE_Y, 24, 7, ST7735_BLACK);
      tft.setCursor(GPS_COURSE_X + 46, GPS_COURSE_Y);
      tft.print(GPScourse, DEC);
      varTmp[4] = GPScourse;
    }
    */

    checkArm(); // show the red bar if armed
  }
  else {
    tft.fillRect(0, 14, 159, 100, ST7735_BLACK);  // clear display to black
    tft.setTextColor(ST7735_RED);
    tft.setCursor(50, 50);
    tft.print("GPS DATA");
    tft.setCursor(35, 65);
    tft.print("NOT AVAILABLE");
  }

}

void show_4_init() {
  pageTmp = page;
  GPSfixTmp = -1;
  GPSsatTmp = -1;
  varTmp[2] = 1;
  //varTmp[3] = 1;
  //varTmp[4] = 1;
  varTmpA = 1;
  varTmpB = 1;

  tft.fillScreen(ST7735_BLACK);  // clear display to black
  tft.setTextColor(ST7735_WHITE);

  tft.setCursor(PAGE_NAME_X - 3, PAGE_NAME_Y);
  tft.print("GPS DATA");

  tft.setCursor(PAGE_NUM_X, PAGE_NUM_Y);
  tft.print(page, DEC);
  tft.print("/");
  tft.print(TOTAL_PAGE, DEC);

  tft.setCursor(GPS_FIX_X, GPS_FIX_Y);
  tft.print("GPS Fix:");

  tft.setCursor(GPS_NUMSAT_X, GPS_NUMSAT_Y);
  tft.print("Sat Num:");

  tft.setCursor(GPS_LAT_X, GPS_LAT_Y);
  tft.print("LAT:");

  tft.setCursor(GPS_LON_X, GPS_LON_Y);
  tft.print("LON:");

  tft.setCursor(GPS_ALT_X, GPS_ALT_Y);
  tft.print("Altitude:");

  /*
  tft.setCursor(GPS_SPEED_X, GPS_SPEED_Y);
  tft.print("Speed:");
  */

  /*
  tft.setCursor(GPS_COURSE_X, GPS_COURSE_Y);
  tft.print("Course:");
  */
}
