// page 5 - Motor Data

void show_5() {
  if (page != pageTmp) {
    show_5_init();
  }

  send_msp(MSP_MOTOR, 0, 0);
  readData();

  for (int j = 0; j <= 7; j++) {
    uint16_t motor = readUInt16(inBuf, j * 2);
    if (motor != varTmp[j]) {
      tft.fillRect(MOTOR_X, MOTOR_Y + (10 * j), 24, 7, ST7735_BLACK);
      tft.setCursor(MOTOR_X, MOTOR_Y + (10 * j));
      tft.print(motor, DEC);
      if (motor < varTmp[j]) {
        if ((motor < 1000) && (motor > 0)) {
          motor = 1000;
        }
        for (int i = norm(motor); i <= norm(varTmp[j]); i++) {
          tft.drawFastVLine(i, MOTOR_Y + (10 * j), 7, ST7735_BLACK);  // clear to black the overage of bar
        }
      }
      else {
        for (int i = norm(varTmp[j]); i <= norm(motor); i++) {
          tft.drawFastVLine(i, MOTOR_Y + (10 * j), 7, ST7735_GREEN); // increase length of bar
        }
      }
    }
    varTmp[j] = motor;
  }
  checkArm(); // show the red bar if armed
}

void show_5_init() {
  pageTmp = page;
  tft.fillScreen(ST7735_BLACK);  // clear display to black
  tft.setTextColor(ST7735_WHITE);

  tft.setCursor(PAGE_NAME_X, PAGE_NAME_Y);
  tft.print("MOTOR");

  tft.setCursor(PAGE_NUM_X, PAGE_NUM_Y);
  tft.print(page, DEC);
  tft.print("/");
  tft.print(TOTAL_PAGE, DEC);

  tft.setCursor(MOTOR_X - 30, MOTOR_Y);
  tft.print("M1:");

  tft.setCursor(MOTOR_X - 30, MOTOR_Y + 10);
  tft.print("M2:");

  tft.setCursor(MOTOR_X - 30, MOTOR_Y + 20);
  tft.print("M3:");

  tft.setCursor(MOTOR_X - 30, MOTOR_Y + 30);
  tft.print("M4:");

  tft.setCursor(MOTOR_X - 30, MOTOR_Y + 40);
  tft.print("M5:");

  tft.setCursor(MOTOR_X - 30, MOTOR_Y + 50);
  tft.print("M6:");

  tft.setCursor(MOTOR_X - 30, MOTOR_Y + 60);
  tft.print("M7:");

  tft.setCursor(MOTOR_X - 30, MOTOR_Y + 70);
  tft.print("M8:");

  varTmp[0] = 1001;
  varTmp[1] = 1001;
  varTmp[2] = 1001;
  varTmp[3] = 1001;
  varTmp[4] = 1001;
  varTmp[5] = 1001;
  varTmp[6] = 1001;
  varTmp[7] = 1001;
}
