// page 6 - Servo Data

void show_6() {
  if (page != pageTmp) {
    show_6_init();
  }

  send_msp(MSP_SERVO, 0, 0);
  readData();

  for (int j = 0; j <= 7; j++) {
    uint16_t servo = readUInt16(inBuf, j * 2);
    if (servo != varTmp[j]) {
      tft.fillRect(SERVO_X, SERVO_Y + (10 * j), 24, 7, ST7735_BLACK);
      tft.setCursor(SERVO_X, SERVO_Y + (10 * j));
      tft.print(servo, DEC);
      if (servo < varTmp[j]) {
        if ((servo < 1000) && (servo > 0)) {
          servo = 1000;
        }
        for (int i = norm(servo); i <= norm(varTmp[j]); i++) {
          tft.drawFastVLine(i, SERVO_Y + (10 * j), 7, ST7735_BLACK);  // clear to black the overage of bar
        }
      }
      else {
        for (int i = norm(varTmp[j]); i <= norm(servo); i++) {
          tft.drawFastVLine(i, SERVO_Y + (10 * j), 7, ST7735_GREEN); // increase length of bar
        }
      }
    }
    varTmp[j] = servo;
  }
  checkArm(); // show the red bar if armed
}

void show_6_init() {
  pageTmp = page;
  tft.fillScreen(ST7735_BLACK);  // clear display to black
  tft.setTextColor(ST7735_WHITE);

  tft.setCursor(PAGE_NAME_X, PAGE_NAME_Y);
  tft.print("SERVO");

  tft.setCursor(PAGE_NUM_X, PAGE_NUM_Y);
  tft.print(page, DEC);
  tft.print("/");
  tft.print(TOTAL_PAGE, DEC);

  tft.setCursor(SERVO_X - 30, SERVO_Y);
  tft.print("S1:");

  tft.setCursor(SERVO_X - 30, SERVO_Y + 10);
  tft.print("S2:");

  tft.setCursor(SERVO_X - 30, SERVO_Y + 20);
  tft.print("S3:");

  tft.setCursor(SERVO_X - 30, SERVO_Y + 30);
  tft.print("S4:");

  tft.setCursor(SERVO_X - 30, SERVO_Y + 40);
  tft.print("S5:");

  tft.setCursor(SERVO_X - 30, SERVO_Y + 50);
  tft.print("S6:");

  tft.setCursor(SERVO_X - 30, SERVO_Y + 60);
  tft.print("S7:");

  tft.setCursor(SERVO_X - 30, SERVO_Y + 70);
  tft.print("S8:");

  varTmp[0] = 1001;
  varTmp[1] = 1001;
  varTmp[2] = 1001;
  varTmp[3] = 1001;
  varTmp[4] = 1001;
  varTmp[5] = 1001;
  varTmp[6] = 1001;
  varTmp[7] = 1001;
}
