// page 7 - Sensors Data

void show_7() {
  if (page != pageTmp) {
    show_7_init();
  }

  send_msp(MSP_RAW_IMU, 0, 0);
  readData();

  int16_t AccX = readInt16(inBuf, 0);
  if (AccX != varTmp[0]) {
    tft.fillRect(ACCX_X + 14, ACCX_Y, 30, 7, ST7735_BLACK);
    tft.setCursor(ACCX_X + 14, ACCX_Y);
    tft.print(AccX, DEC);
    varTmp[0] = AccX;
  }

  int16_t AccY = readInt16(inBuf, 1);
  if (AccY != varTmp[1]) {
    tft.fillRect(ACCY_X + 14, ACCY_Y, 30, 7, ST7735_BLACK);
    tft.setCursor(ACCY_X + 14, ACCY_Y);
    tft.print(AccY, DEC);
    varTmp[1] = AccY;
  }

  int16_t AccZ = readInt16(inBuf, 2);
  if (AccZ != varTmp[2]) {
    tft.fillRect(ACCZ_X + 14, ACCZ_Y, 30, 7, ST7735_BLACK);
    tft.setCursor(ACCZ_X + 14, ACCZ_Y);
    tft.print(AccZ, DEC);
    varTmp[2] = AccZ;
  }

  int16_t GyrX = readInt16(inBuf, 3);
  if (GyrX != varTmp[3]) {
    tft.fillRect(GYRX_X + 14, GYRX_Y, 30, 7, ST7735_BLACK);
    tft.setCursor(GYRX_X + 14, GYRX_Y);
    tft.print(GyrX, DEC);
    varTmp[3] = GyrX;
  }

  int16_t GyrY = readInt16(inBuf, 4);
  if (GyrY != varTmp[4]) {
    tft.fillRect(GYRY_X + 14, GYRY_Y, 30, 7, ST7735_BLACK);
    tft.setCursor(GYRY_X + 14, GYRY_Y);
    tft.print(GyrY, DEC);
    varTmp[4] = GyrY;
  }

  int16_t GyrZ = readInt16(inBuf, 5);
  if (GyrZ != varTmp[5]) {
    tft.fillRect(GYRZ_X + 14, GYRZ_Y, 30, 7, ST7735_BLACK);
    tft.setCursor(GYRZ_X + 14, GYRZ_Y);
    tft.print(GyrZ, DEC);
    varTmp[5] = GyrZ;
  }

  int16_t MagX = readInt16(inBuf, 6);
  if (MagX != varTmp[6]) {
    tft.fillRect(MAGX_X + 14, MAGX_Y, 30, 7, ST7735_BLACK);
    tft.setCursor(MAGX_X + 14, MAGX_Y);
    tft.print(MagX, DEC);
    varTmp[6] = MagX;
  }

  int16_t MagY = readInt16(inBuf, 7);
  if (MagY != varTmp[7]) {
    tft.fillRect(MAGY_X + 14, MAGY_Y, 30, 7, ST7735_BLACK);
    tft.setCursor(MAGY_X + 14, MAGY_Y);
    tft.print(MagY, DEC);
    varTmp[7] = MagY;
  }

  int16_t MagZ = readInt16(inBuf, 8);
  if (MagZ != varTmp[8]) {
    tft.fillRect(MAGZ_X + 14, MAGZ_Y, 30, 7, ST7735_BLACK);
    tft.setCursor(MAGZ_X + 14, MAGZ_Y);
    tft.print(MagZ, DEC);
    varTmp[8] = MagZ;
  }

  send_msp(MSP_ATTITUDE, 0, 0);
  readData();

  int16_t head = readInt16(inBuf, 2);
  if (head != varTmp[9]) {
    tft.fillRect(HEAD_X + 32, HEAD_Y, 30, 7, ST7735_BLACK);
    tft.setCursor(HEAD_X + 32, HEAD_Y);
    tft.print(head, DEC);
    varTmp[9] = head;
    float radHead = (head * 3.1415) / 180;
    int x = sin(radHead) * 12;
    int y = cos(radHead) * 12;
    tft.fillCircle(COMPASS_X, COMPASS_Y, 12, ST7735_BLACK);
    tft.drawLine((COMPASS_X - x), (COMPASS_Y + y), (COMPASS_X + x), (COMPASS_Y - y), ST7735_GREEN); // draw compass arrow
  }



  send_msp(MSP_ALTITUDE, 0, 0);
  readData();

  int32_t altitude = readInt32(inBuf, 0);
  if (altitude != varTmpC) {
    tft.fillRect(ALT_X + 26, ALT_Y, 32, 7, ST7735_BLACK);
    tft.setCursor(ALT_X + 26, ALT_Y);
    tft.print(altitude, DEC);
    varTmpC = altitude;
  }

  //checkArm(); // show the red bar if armed
}

void show_7_init() {
  pageTmp = page;
  tft.fillScreen(ST7735_BLACK);  // clear display to black
  tft.setTextColor(ST7735_WHITE);

  tft.setCursor(PAGE_NAME_X, PAGE_NAME_Y);
  tft.print("SENSORS");

  tft.setCursor(PAGE_NUM_X, PAGE_NUM_Y);
  tft.print(page, DEC);
  tft.print("/");
  tft.print(TOTAL_PAGE, DEC);

  tft.setCursor(0, ACCX_Y);
  tft.print("ACC");

  tft.setCursor(ACCX_X, ACCX_Y);
  tft.print("X:");

  tft.setCursor(ACCY_X, ACCY_Y);
  tft.print("Y:");

  tft.setCursor(ACCZ_X, ACCZ_Y);
  tft.print("Z:");

  tft.setCursor(0, GYRX_Y);
  tft.print("GYR");

  tft.setCursor(GYRX_X, GYRX_Y);
  tft.print("X:");

  tft.setCursor(GYRY_X, GYRY_Y);
  tft.print("Y:");

  tft.setCursor(GYRZ_X, GYRZ_Y);
  tft.print("Z:");

  tft.setCursor(0, MAGX_Y);
  tft.print("MAG");

  tft.setCursor(MAGX_X, MAGX_Y);
  tft.print("X:");

  tft.setCursor(MAGY_X, MAGY_Y);
  tft.print("Y:");

  tft.setCursor(MAGZ_X, MAGZ_Y);
  tft.print("Z:");

  tft.setCursor(HEAD_X, HEAD_Y);
  tft.print("HEAD:");
  tft.drawCircle(COMPASS_X, COMPASS_Y, 13, ST7735_BLUE);

  tft.setCursor(ALT_X, ALT_Y);
  tft.print("ALT:");

  varTmp[0] = 1000;
  varTmp[1] = 1000;
  varTmp[2] = 1000;
  varTmp[3] = 1000;
  varTmp[4] = 1000;
  varTmp[5] = 1000;
  varTmp[6] = 1000;
  varTmp[7] = 1000;
  varTmp[8] = 1000;
  varTmp[9] = 1000;
  varTmp[10] = 1000;

  varTmpC = 1000;

}
